"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require('path');
var os = require('os');
var fs = require('fs');
var colors = require('colors');
var yaml = require('js-yaml');
var packTo = require('@serverless-devs/s-zip').packTo;
var Context_1 = require("./Context");
var utils_1 = require("./utils");
var Component = /** @class */ (function () {
    function Component(id, context) {
        this.state = {};
        this.id = id || this.constructor.name;
        if (!context) {
            context = new Context_1.default();
        }
        this.name = "instance_" + Date.now();
        this.context = {
            instance: context
        };
    }
    Component.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.context.instance.init()];
                    case 1:
                        _b.sent();
                        _a = this;
                        return [4 /*yield*/, this.context.instance.getState(this.id)];
                    case 2:
                        _a.state = _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Component.prototype.save = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, id, state;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this, id = _a.id, state = _a.state;
                        return [4 /*yield*/, this.context.instance.setState(id, state)];
                    case 1:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Component.prototype.sleep = function (ms) {
        return new Promise(function (resolve) {
            setTimeout(resolve, ms);
        });
    };
    Component.prototype.getNewKey = function (key) {
        try {
            var tempKey = key.split('-');
            var resultKey = '';
            for (var i = 0; i < tempKey.length; i++) {
                if (i === 0) {
                    resultKey = tempKey[0];
                }
                else {
                    resultKey = resultKey + tempKey[i][0].toUpperCase() + tempKey[i].slice(1, tempKey[i].length);
                }
            }
            return resultKey;
        }
        catch (ex) {
            return key;
        }
    };
    Component.prototype.getSpace = function (num) {
        var tempSpace = ' ';
        var tempResult = '';
        for (var i = 0; i < (num > 0 ? parseInt(String(num)) : 0); i++) {
            tempResult = tempResult + tempSpace;
        }
        return tempResult;
    };
    Component.prototype.getLogMessage = function (message, type, style, num) {
        return this.getSpace(num || 2) + (style === 1 ? type : '') + message;
    };
    Component.prototype.isColor = function () {
        var profPath = path.join(os.homedir(), ".s/set-config.yml");
        try {
            var profile = yaml.safeLoad(fs.readFileSync(profPath, 'utf8')) || {};
            return profile['output-color'];
        }
        catch (err) {
            return true;
        }
    };
    Component.prototype.args = function (args, boolList, moreList, argsList) {
        /*
         *  变更：
         *     1. 二级指令增加转换，例如a-b变成aB
         *     2. 主Key增加转换，例如a-b变成aB
         */
        var argsData = {};
        var commandData = [];
        var argsStatus = argsList === undefined ? true : false;
        boolList = boolList || [];
        moreList = moreList || [];
        argsList = argsList || [];
        args = args || '';
        if (args) {
            var tempList = args.split(' ');
            var temp = void 0;
            var sourceTemp = void 0;
            var listTemp = void 0;
            var indexTemp = void 0;
            for (var i = 0; i < tempList.length; i++) {
                // eslint-disable-next-line @typescript-eslint/ban-ts-comment
                // @ts-ignore
                if (tempList[i].startsWith('-') && (argsStatus || argsList.indexOf(tempList[i]) >= 0)) {
                    console.log(tempList[i]);
                    // eslint-disable-next-line no-unused-vars
                    indexTemp = i;
                    var tempArgs = tempList[i].startsWith('--')
                        ? tempList[i].slice(2, tempList[i].length)
                        : tempList[i].slice(1, tempList[i].length);
                    tempArgs = this.getNewKey(tempArgs);
                    if (argsData.hasOwnProperty(tempArgs)) {
                        listTemp = tempArgs;
                    }
                    else {
                        argsData[tempArgs] = undefined;
                    }
                    // eslint-disable-next-line @typescript-eslint/ban-ts-comment
                    // @ts-ignore
                    temp = boolList.indexOf(tempArgs) !== -1 ? undefined : tempArgs;
                    // eslint-disable-next-line @typescript-eslint/ban-ts-comment
                    // @ts-ignore
                    sourceTemp = boolList.indexOf(tempArgs) !== -1 ? undefined : tempList[i];
                }
                else {
                    if (temp) {
                        if (temp === listTemp) {
                            // 此时是传入了list数组
                            if (i - indexTemp > 1) {
                                var tempStrIndex = argsData[temp].length - 1;
                                argsData[temp][tempStrIndex] = (argsData[temp][tempStrIndex] ? argsData[temp][tempStrIndex] + ' ' : '') + tempList[i];
                            }
                            else {
                                if (!(argsData[temp] instanceof Array)) {
                                    argsData[temp] = [argsData[temp]];
                                }
                                argsData[temp].push(tempList[i]);
                            }
                        }
                        else {
                            // eslint-disable-next-line @typescript-eslint/ban-ts-comment
                            // @ts-ignore
                            if (moreList.indexOf(temp) !== -1 || argsList.indexOf(sourceTemp) !== -1) {
                                argsData[temp] = (argsData[temp] ? argsData[temp] + ' ' : '') + tempList[i];
                            }
                            else {
                                if (argsData[temp]) {
                                    commandData.push(tempList[i]);
                                }
                                else {
                                    argsData[temp] = tempList[i];
                                }
                            }
                        }
                    }
                    else {
                        // 修复非-/--开头的变成驼峰格式
                        commandData.push(tempList[i]);
                    }
                }
            }
        }
        for (var eveItem in argsData) {
            if (argsData[eveItem] === undefined) {
                argsData[eveItem] = true;
            }
        }
        return {
            'Commands': commandData,
            'Parameters': argsData
        };
    };
    Component.prototype.help = function (inputs, message) {
        try {
            var tempList = inputs.Args.split(' ');
            if (tempList.includes('--help') || tempList.includes('-h')) {
                console.log("\n    " + message.description + "\n");
                if (message.commands && message.commands.length > 0) {
                    console.log("\n  Commands: ");
                    for (var i = 0; i < message.commands.length; i++) {
                        if (message.commands[i].name && message.commands[i].desc) {
                            console.log("      " + message.commands[i].name + ": " + message.commands[i].desc);
                        }
                    }
                }
                if (message.args && message.args.length > 0) {
                    console.log("\n  Args: ");
                    for (var i = 0; i < message.args.length; i++) {
                        if (message.args[i].name && message.args[i].desc) {
                            console.log("      " + message.args[i].name + ": " + message.args[i].desc);
                        }
                    }
                }
                console.log('\n');
                process.exit(0);
            }
        }
        catch (ex) { }
    };
    Component.prototype.log = function (message, option) {
        var _a = option || {}, style = _a.style, num = _a.num, output = _a.output;
        message = this.getLogMessage(message, '[LOG] ', style || 0, num || 2);
        if (process.env['verbose'] === 'true' || output === true) {
            console.log(this.isColor() ? colors.grey(message) : message);
        }
    };
    Component.prototype.warn = function (message, option) {
        var _a = option || {}, style = _a.style, num = _a.num;
        message = this.getLogMessage(message, '[WARN] ', style || 0, num || 2);
        console.log(this.isColor() ? colors.yellow(message) : message);
    };
    Component.prototype.error = function (message, option) {
        var _a = option || {}, style = _a.style, num = _a.num;
        message = this.getLogMessage(message, '[ERROR] ', style || 0, num || 2);
        throw new Error(message);
        // console.log(this.isColor() ? colors.red(message) : message);
    };
    Component.prototype.info = function (message, option) {
        var _a = option || {}, style = _a.style, num = _a.num;
        message = this.getLogMessage(message, '[INFO] ', style || 0, num || 2);
        console.log(this.isColor() ? colors.blue(message) : message);
    };
    Component.prototype.success = function (message, option) {
        var _a = option || {}, style = _a.style, num = _a.num;
        message = this.getLogMessage(message, '[LOG] ', style || 0, num || 2);
        console.log(this.isColor() ? colors.green(message) : message);
    };
    Component.prototype.zip = function (packToParame) {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, packTo(packToParame)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_1 = _a.sent();
                        throw new Error(err_1);
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Component.prototype.load = function (componentName, componentAlias, provider) {
        if (componentAlias === void 0) { componentAlias = ''; }
        if (provider === void 0) { provider = 'alibaba'; }
        return __awaiter(this, void 0, void 0, function () {
            var externalComponentPath, version, tempPath, childComponent, childComponentId, childComponentInstance;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, utils_1.getRemoteComponentVersion({
                            name: componentName,
                            provider: provider,
                            type: 'component'
                        })];
                    case 1:
                        version = _a.sent();
                        tempPath = "./" + componentName + "-" + provider + "@" + version;
                        if (this.context.instance.componentPathRoot) { // s component
                            externalComponentPath = path.resolve(this.context.instance.componentPathRoot, tempPath, 'index.js');
                        }
                        else {
                            externalComponentPath = path.resolve(componentName);
                        }
                        if (!!fs.existsSync(externalComponentPath)) return [3 /*break*/, 3];
                        return [4 /*yield*/, utils_1.downComponent(componentName, provider, path.join(this.context.instance.componentPathRoot, tempPath))];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3: return [4 /*yield*/, require(externalComponentPath)];
                    case 4:
                        childComponent = _a.sent();
                        childComponentId = this.id + "." + (componentAlias || childComponent.name);
                        childComponentInstance = new childComponent(childComponentId, this.context.instance);
                        if (!(childComponentInstance instanceof Component)) return [3 /*break*/, 6];
                        return [4 /*yield*/, childComponentInstance.init()];
                    case 5:
                        _a.sent();
                        childComponentInstance.context.status = function () { };
                        return [3 /*break*/, 8];
                    case 6:
                        if (!childComponentInstance.init) return [3 /*break*/, 8];
                        return [4 /*yield*/, childComponentInstance.init()];
                    case 7:
                        _a.sent();
                        _a.label = 8;
                    case 8: return [2 /*return*/, childComponentInstance];
                }
            });
        });
    };
    return Component;
}());
exports.default = Component;
//# sourceMappingURL=Component.js.map